MODULE vector
  USE genmod

CONTAINS

  FUNCTION Norm(V)
  IMPLICIT NONE
    REAL(rstd)            :: Norm
    REAL(rstd),INTENT(IN) :: V(3)
    
    Norm=sqrt(V(1)*V(1)+V(2)*V(2)+V(3)*V(3))
  
  END FUNCTION Norm
  
  FUNCTION dot_product(V1,V2)
  IMPLICIT NONE
    REAL(rstd)       :: dot_product
    REAL(rstd),INTENT(IN) :: V1(3)
    REAL(rstd),INTENT(IN) :: V2(3)
    
    dot_product=V1(1)*V2(1)+V1(2)*V2(2)+V1(3)*V2(3)
    
   END FUNCTION dot_product
   
   FUNCTION cross_product(V1,V2)
   IMPLICIT NONE
     REAL(rstd)     ::cross_product(3)
     REAL(rstd),INTENT(IN) :: V1(3)
     REAL(rstd),INTENT(IN) :: V2(3)
    
     cross_product(1)=V1(2)*V2(3)-V1(3)*V2(2)
     cross_product(2)=V1(3)*V2(1)-V1(1)*V2(3)
     cross_product(3)=V1(1)*V2(2)-V1(2)*V2(1)
     
    END FUNCTION cross_product


   SUBROUTINE cross_product2(V1,V2,cross_product)
   IMPLICIT NONE
     REAL(rstd),INTENT(OUT):: cross_product(3)
     REAL(rstd),INTENT(IN) :: V1(3)
     REAL(rstd),INTENT(IN) :: V2(3)
    
     cross_product(1)=V1(2)*V2(3)-V1(3)*V2(2)
     cross_product(2)=V1(3)*V2(1)-V1(1)*V2(3)
     cross_product(3)=V1(1)*V2(2)-V1(2)*V2(1)
     
    END SUBROUTINE cross_product2

    FUNCTION arc(lon1,lat1, lon2,lat2)
      REAL(rstd) :: lon1,lat1, lon2,lat2, arc2, &
           x1,x2,x3,y1,y2,y3,z1,z2,z3
      x1=cos(lat1)*cos(lon1)
      x2=cos(lat2)*cos(lon2)
      y1=cos(lat1)*sin(lon1)
      y2=cos(lat2)*sin(lon2)
      z1=sin(lat1)
      z2=sin(lat2)
      x3=y1*z2-y2*z1
      y3=z1*x2-z2*x1
      z3=x1*y2-x2*y1
      arc=ASIN(SQRT(x3*x3+y3*y3+z3*z3))
    END FUNCTION arc

END MODULE vector
